package com.bpcl.lpg.core.jalo;

import java.util.Collections;
import java.util.HashMap;
import de.hybris.platform.jalo.c2l.C2LManager;
import de.hybris.platform.jalo.c2l.Language;
import de.hybris.platform.jalo.JaloInvalidParameterException;
import de.hybris.platform.jalo.SessionContext;
import de.hybris.platform.jalo.Item;
import java.util.Map;
import de.hybris.platform.directpersistence.annotation.SLDSafe;
import de.hybris.platform.jalo.GenericItem;

@SLDSafe
public class LpgUndeliveredReason extends GenericItem
{
    public static final String CODE = "code";
    public static final String DESCRIPTION = "description";
    protected static final Map<String, Item.AttributeMode> DEFAULT_INITIAL_ATTRIBUTES;
    
    protected Map<String, Item.AttributeMode> getDefaultAttributeModes() {
        return LpgUndeliveredReason.DEFAULT_INITIAL_ATTRIBUTES;
    }
    
    public Integer getCode(final SessionContext ctx) {
        return (Integer)this.getProperty(ctx, "code".intern());
    }
    
    public Integer getCode() {
        return this.getCode(this.getSession().getSessionContext());
    }
    
    public int getCodeAsPrimitive(final SessionContext ctx) {
        final Integer value = this.getCode(ctx);
        return (value != null) ? value : 0;
    }
    
    public int getCodeAsPrimitive() {
        return this.getCodeAsPrimitive(this.getSession().getSessionContext());
    }
    
    public void setCode(final SessionContext ctx, final Integer value) {
        this.setProperty(ctx, "code".intern(), (Object)value);
    }
    
    public void setCode(final Integer value) {
        this.setCode(this.getSession().getSessionContext(), value);
    }
    
    public void setCode(final SessionContext ctx, final int value) {
        this.setCode(ctx, Integer.valueOf(value));
    }
    
    public void setCode(final int value) {
        this.setCode(this.getSession().getSessionContext(), value);
    }
    
    public String getDescription(final SessionContext ctx) {
        if (ctx == null || ctx.getLanguage() == null) {
            throw new JaloInvalidParameterException("LpgUndeliveredReason.getDescription requires a session language", 0);
        }
        return (String)this.getLocalizedProperty(ctx, "description".intern());
    }
    
    public String getDescription() {
        return this.getDescription(this.getSession().getSessionContext());
    }
    
    public Map<Language, String> getAllDescription(final SessionContext ctx) {
        return this.getAllLocalizedProperties(ctx, "description".intern(), C2LManager.getInstance().getAllLanguages());
    }
    
    public Map<Language, String> getAllDescription() {
        return this.getAllDescription(this.getSession().getSessionContext());
    }
    
    public void setDescription(final SessionContext ctx, final String value) {
        if (ctx == null) {
            throw new JaloInvalidParameterException("ctx is null", 0);
        }
        if (ctx.getLanguage() == null) {
            throw new JaloInvalidParameterException("LpgUndeliveredReason.setDescription requires a session language", 0);
        }
        this.setLocalizedProperty(ctx, "description".intern(), (Object)value);
    }
    
    public void setDescription(final String value) {
        this.setDescription(this.getSession().getSessionContext(), value);
    }
    
    public void setAllDescription(final SessionContext ctx, final Map<Language, String> value) {
        this.setAllLocalizedProperties(ctx, "description".intern(), (Map)value);
    }
    
    public void setAllDescription(final Map<Language, String> value) {
        this.setAllDescription(this.getSession().getSessionContext(), value);
    }
    
    static {
        final Map<String, Item.AttributeMode> tmp = new HashMap<String, Item.AttributeMode>();
        tmp.put("code", Item.AttributeMode.INITIAL);
        tmp.put("description", Item.AttributeMode.INITIAL);
        DEFAULT_INITIAL_ATTRIBUTES = Collections.unmodifiableMap((Map<? extends String, ? extends Item.AttributeMode>)tmp);
    }
}
